<?php
/**
 * Partials Module
 */

function partial_views_style_plugins() {
  $viewStyles = partial_db_get_view_styles();
  if (!empty($viewStyles)) {
    foreach ($viewStyles as $viewStyle) {
      $items[$viewStyle->title] = array(
        'name' => t("Partial: $viewStyle->title"),
        'theme' => "partial_views_style",
        'needs_table_header' => TRUE,
        'needs_fields' => TRUE,
        'even_empty' => TRUE,
      );
    }
  }
  return $items;
}

function theme_partial_views_style($view, $nodes, $type) {
	$typeRef = $type . '_type';
  
  $partial = db_fetch_object(db_query(db_rewrite_sql("SELECT n.nid FROM {node} n WHERE LOWER(title) = LOWER('%s')"), $view->$typeRef));
//  $partial = node_load($partial->nid);
  $title = divSafe($view->page_type);
  $retVal = "<div class='views_$title'>";
  foreach ($nodes as $count => $n) {
    $node = node_load($n->nid);
    foreach ($n as $key=>$value) {
      if ($key != 'nid') {
        $node->$key = $value;
      }
    }
    $node->views_index = $count + 1;
    $page = $_GET['page'];
    if ($page > 0) {
      $node->views_index += $page * $view->nodes_per_page;
    }
    $retVal .= partial_render($partial->nid, $node);
  }
  $retVal .= '</div>';
  return $retVal;
}

/*
function partial_views_default_views() {
  $view = new stdClass();
  $view->name = 'components';
  $view->description = t('Listing of partials.');
  $view->access = array ();
  $view->page = TRUE;
  $view->page_title = t('Partials');
  $view->page_header = '';
  $view->page_empty = 'There are no partials in the system.';
  $view->page_header_format = '1';
  $view->page_type = 'table';
  $view->url = 'admin/build/components';
  $view->use_pager = TRUE;
  $view->nodes_per_page = '40';
  $view->sort = array (
    array (
      'tablename' => 'node',
      'field' => 'created',
      'sortorder' => 'ASC',
      'options' => '',
    ),
  );
  $view->field = array (
    array (
      'tablename' => 'node',
      'field' => 'title',
      'label' => t('Title'),
      'handler' => 'views_handler_field_nodelink_with_mark',
    ),
  );
  $view->filter = array ();
  $view->requires = array(node);
  $views[$view->name] = $view;
  return $views;
}
*/
